<?php

// Добавляем меню админки страницу настроек плагина
add_action('admin_menu', function(){
    // Добавляем подменю в раздел Options(Настройки)
    add_options_page( 'GVSoft Photobox'.' v'.GVPB_VER, 'GVSoft Photobox', 
        'administrator', 'GVSoft_Photobox', 'gvphotobox_options_page_output' );
});

// Вывод страницы настроек плагина
function gvphotobox_options_page_output(){
    require GVPB_PATH . 'defparam.php';
?>
<div id="gvpb-settings" class="wrap">
    <h1><?php echo get_admin_page_title() ?></h1><h2><span></span></h2>
    <p><?php _e('More information and updates can be found at:','gvsoft-photobox')?>
    <a href="http://gvsoft.ru/development/wordpress-plugins/photobox">
        http://gvsoft.ru/development/wordpress-plugins/photobox
    </a>
    </p>
    
<form method="post" action="options.php">
    <?php settings_fields( 'gvphotobox-settings' ); // скрытые защитные поля ?>
    <table>
        <tr>
            <th scope="row" align="right"><?= __('Border color','gvsoft-photobox')?></th>
            <td><input type="text" name="gvpb_border_color" size="8" 
                value="<?=esc_attr(get_option('gvpb_border_color',$gvpb_def_params['gvpb_border_color']));?>"></td>
        </tr>
        <tr>
            <th scope="row" align="right"><?= __('Border width','gvsoft-photobox')?></th>
            <td><input type="text" name="gvpb_border_width" size="2" 
                value="<?=esc_attr(get_option('gvpb_border_width',$gvpb_def_params['gvpb_border_width']));?>"></td>
        </tr>        
        <tr>
            <th scope="row" align="right"><?= __('Color of buttons','gvsoft-photobox')?></th>
            <td><input type="text" name="gvpb_button_color" size="8" 
                value="<?=esc_attr(get_option('gvpb_button_color',$gvpb_def_params['gvpb_button_color']));?>"></td>
        </tr>
        <tr>
            <th scope="row" align="right"><?= __('Color of stickers','gvsoft-photobox')?></th>
            <td><input type="text" name="gvpb_label_color" size="8" 
                value="<?=esc_attr(get_option('gvpb_label_color',$gvpb_def_params['gvpb_label_color']));?>"></td>
        </tr>
        <tr>
            <th scope="row" align="right"><?= __('Border radius','gvsoft-photobox')?></th>
            <td><input type="text" name="gvpb_border_radius" size="2" 
                value="<?=esc_attr(get_option('gvpb_border_radius',$gvpb_def_params['gvpb_border_radius']));?>"></td>
        </tr>        
        <tr>
            <th scope="row" align="right"><?php _e('Autoplay delay (ms)','gvsoft-photobox')?></th>
            <td><input type="text" name="gvpb_delay" size="4" 
                value="<?=esc_attr(get_option('gvpb_delay',$gvpb_def_params['gvpb_delay']))?>">
                <?php _e('for slide-show mode(autoplay)','gvsoft-photobox')?>
            </td>
        </tr>
        <tr><th colspan="2"><hr></th></tr>
    <tr>
        <th scope="row" align="right"><?php _e('Animation effect','gvsoft-photobox')?></th>
        <td><input type="checkbox" name="gvpb_animation"
        value="1" <?php checked(1,get_option('gvpb_animation',$gvpb_def_params['gvpb_animation']))?>>
        <?php _e('if the checkbox is deselected, the parameters below are ignored','gvsoft-photobox')?>
        </td>
    </tr>
    <tr>
        <th scope="row" align="right"><?php _e("Speed old image animation",'gvsoft-photobox')?></th>
        <td><input type="text" name="gvpb_speedOldImgAnim" size="6" 
        value="<?=esc_attr(get_option('gvpb_speedOldImgAnim',$gvpb_def_params['gvpb_speedOldImgAnim']))?>">
        <?php _e('possible value:','gvsoft-photobox')?> normal,slow,fast or number(ms)
        </td>
    </tr>
    <tr>
        <th scope="row" align="right"><?php _e("Speed new image animation",'gvsoft-photobox')?></th>
        <td><input type="text" name="gvpb_speedNewImgAnim" size="6" 
        value="<?=esc_attr(get_option('gvpb_speedNewImgAnim',$gvpb_def_params['gvpb_speedNewImgAnim']))?>">
        <?php _e('possible value:','gvsoft-photobox')?> normal,slow,fast or number(ms)
        </td>
    </tr>
    <tr>
        <th scope="row" align="right"><?php _e("Old image animation effect name",'gvsoft-photobox')?></th>
        <td><input type="text" name="gvpb_OldImgAnim" size="6" 
        value="<?=esc_attr(get_option('gvpb_OldImgAnim',$gvpb_def_params['gvpb_OldImgAnim']))?>">
        <?php _e('possible value:','gvsoft-photobox')?> fadeOut,hide,slideUp
        </td>
    </tr>
    <tr>
        <th scope="row" align="right"><?php _e("New image animation effect name",'gvsoft-photobox')?></th>
        <td><input type="text" name="gvpb_NewImgAnim" size="6" 
        value="<?=esc_attr(get_option('gvpb_NewImgAnim',$gvpb_def_params['gvpb_NewImgAnim']))?>">
        <?php _e('possible value:','gvsoft-photobox')?> fadeIn,show,slideDown
        </td>
    </tr>    
        
    </table>
    <p class="submit">
        <button type="reset" class="clear button button-secondary"><?php _e('Clear','gvsoft-photobox')?></button>
        <input type="submit" class="button-primary" name="save_options" 
            value="<?php _e('Save Changes','gvsoft-photobox');?>">
        <button type="reset" class="loaddefset button button-secondary">
            <?php _e('Load default settings','gvsoft-photobox')?>
        </button>
    </p>
</form>
    <b><?php _e('Donation to the author','gvsoft-photobox')?></b>
    <a class="button button-secondary" href="https://www.paypal.me/gvsoft">«PayPal.Me»</a>
    <a class="button button-secondary" href="https://yasobe.ru/na/wpplugin">«Я.Соберу»</a>
</div>
<?php
}

/**
 * Регистрируем настройки.
 */
add_action( 'admin_init', 'gvphotobox_settings' );
function gvphotobox_settings(){
    register_setting( 'gvphotobox-settings', 'gvpb_border_color' );
    register_setting( 'gvphotobox-settings', 'gvpb_border_width' );
    register_setting( 'gvphotobox-settings', 'gvpb_button_color' );
    register_setting( 'gvphotobox-settings', 'gvpb_label_color' );
    register_setting( 'gvphotobox-settings', 'gvpb_border_radius' );
    register_setting( 'gvphotobox-settings', 'gvpb_delay' );
    
    register_setting( 'gvphotobox-settings', 'gvpb_animation' );
    register_setting( 'gvphotobox-settings', 'gvpb_speedOldImgAnim' );
    register_setting( 'gvphotobox-settings', 'gvpb_speedNewImgAnim' );
    register_setting( 'gvphotobox-settings', 'gvpb_OldImgAnim' );
    register_setting( 'gvphotobox-settings', 'gvpb_NewImgAnim' );
}

// Подключаем скрипты и стили
add_action( 'admin_enqueue_scripts', function(){
    // подключаем IRIS
    wp_enqueue_script( 'wp-color-picker' );
    wp_enqueue_style( 'wp-color-picker' );
});

// js код
add_action('admin_footer', function(){
?>
<script type="text/javascript">
    jQuery(document).ready(function($){
        
        var boxNotes$ = $('#gvpb-settings');
        var boxTitle$ = $('h2 span', boxNotes$);
        
        // Подключить Iris к полям формы выбора цвета
        var myIris$ = $('input[name*="color"]', boxNotes$).wpColorPicker();

        // Очистка полей и изменение заголовка на дефолтный
        $('.clear', boxNotes$).click(function(){
            $('input[type="text"]', boxNotes$).attr('value','');
            myIris$.wpColorPicker('color','#f7f7f7');
        });

        $('.loaddefset', boxNotes$).click(function(e){
            e.preventDefault();
            if (!confirm("Are you sure? Вы уверены?")) return;
            boxNotes$.animate({opacity: 0.5}, 300); // Анимация

            var request = $.get( // Ajax запрос
                ajaxurl,
                {
                    action: 'load_def_gvpb_settings',
                    gvpb_settings_content: $('form', boxNotes$).serialize(),
                    security: '<?php echo wp_create_nonce( "gvpb_settings_nonce" ); ?>'
                }
            );

            // Обработка успешного запроса
            request.done(function(response){
                var title$ = $('h2 span', boxNotes$).text(response.data.message);
                var properties = JSON.parse( response.data.answer );
                // Установка значений всех полей
                for ( var propName in properties ) {
                    $(`input[name="${propName}"]`, boxNotes$).attr('value',properties[propName]);
                    // Переинициализация(установка цвета) в wpColorPicker элементе
                    if (/color/i.test(propName))
                        $(`input[name="${propName}"]`, boxNotes$).wpColorPicker('color', properties[propName]);
                }                
                if (response.success) {
                    title$.css('color', 'green');
                } else {
                    title$.css('color', 'orangered');
                }
            });

            // Обработка запроса с необрабатываемой ошибкой
            request.fail(function(){
                $('h2 span', boxNotes$)
                    .text('<?php _e('Unexpected error!','gvsoft-photobox');?>')
                    .css('color', 'red');
            });

            // Обработка запроса в обоих случаях
            request.always(function(response){
                boxNotes$.animate(
                    {opacity: 1}, 300, '',
                    function(){
                        setTimeout(function(){
                            boxTitle$.text('').attr('style','');
                        }, 2000);
                    }
                );
            });
        });
    });
</script>
<?php    
});

// Загрузить аяксом значение настроек по умолчанию
add_action( 'wp_ajax_load_def_gvpb_settings', function(){
    require GVPB_PATH . 'defparam.php';
    
    check_ajax_referer( 'gvpb_settings_nonce', 'security' );
    
    if ( ! isset($_GET['gvpb_settings_content']) || ! current_user_can('activate_plugins') ) {
        return;
    }
    
    unset($_GET['action']);// удаляем "лишний" элемент
    $settings_content = explode('&', $_GET['gvpb_settings_content']);
    
    $client_params = array();
    foreach($settings_content as $item) {
        $m = explode('=', $item);
        $client_params[ $m[0] ] = $m[1];
    }
    
    $loaded_params = array_intersect_key($gvpb_def_params, $client_params);
    
    // Обновляем данные в базе(исходные значения параметров)
    $update = FALSE; // флаг изменения хотя бы 1 поля
    foreach($loaded_params as $key => $value ) {
        $status = update_option($key, $value, false);
        if ($status) $update = TRUE;
    }
    
    //exit( json_encode($loaded_params) );
    if ( $update ) {
        wp_send_json_success( [
            'message'=>__('The command is completed','gvsoft-photobox'),
            'answer'=>json_encode($loaded_params),
            ] ,200 );
    } else {
        wp_send_json_error( [
            'message'=>__('The data has not changed','gvsoft-photobox'),
            'answer'=>json_encode($loaded_params),
        ]);
    }    
});
