@font-face {
    font-family: 'FontAwesome';
    src: url('<?=GVPB_URL?>fonts/fontawesome-webfont.eot?v=4.7.0');
    src: url('<?=GVPB_URL?>fonts/fontawesome-webfont.eot?#iefix&v=4.7.0') format('embedded-opentype'), url('<?=GVPB_URL?>fonts/fontawesome-webfont.woff2?v=4.7.0') format('woff2'), url('<?=GVPB_URL?>fonts/fontawesome-webfont.woff?v=4.7.0') format('woff'), url('<?=GVPB_URL?>fonts/fontawesome-webfont.ttf?v=4.7.0') format('truetype'), url('<?=GVPB_URL?>fonts/fontawesome-webfont.svg?v=4.7.0#fontawesomeregular') format('svg');
    font-weight: normal;
    font-style: normal;
}
/*внешний контейнер для полноразмерного фото*/
#gv-photobox{
    background-color: <?=$border_color?>;
    z-index: 101;
    border-radius: <?=$border_radius?>;
    padding: <?=$border_width?>;
    
    position: fixed;
    top: 50%;
    left: 50%;
}
.h-centre{text-align: center;}
/*элемент для размерного изображения*/
img#gv-img-display {
    border-radius: <?=$border_radius?>;
    overflow: auto;
    cursor: pointer;
}
/*Размер экрана меньше 1366*/
@media all and (max-width: 1366px) {
    img#gv-img-display {
        max-width: 1024px;
        max-height: 555px;
    }
}
/*Размер экрана меньше 1024*/
@media all and (max-width: 1024px) {
    img#gv-img-display {
        max-width: 980px;
        max-height: 505px;
    }
}
/*Размер экрана меньше 980px (резиновый макет)*/
@media screen and (max-width: 980px) {
    img#gv-img-display {
        max-width: 95%;
        height: auto;
    }
}

/*контейнер для элементов управления*/
.gv-control-bar {
    position: absolute;
    bottom: -18px;
    width: 158px;
    left: 50%;
    margin-left: -79px;
}
/*элементы управления навигацией по фоткам*/
.gv-control-bar button{
    cursor: pointer;
    height: 28px;
    width: 28px;
    background-color: <?=$button_color?>;
    border-radius: <?=$border_radius?>;
    position: relative;  
    border: 1px solid DimGray;
}
.fa{
    display: inline-block;
    font-family: FontAwesome;
    font-style: normal;
    font-weight: normal;
    text-decoration: inherit;    
}
.fa:before {
    color: <?=$label_color?>;/*цвет фигур шрифтовых иконок*/
    font-size: 18px;
    position: absolute;
    padding-right: 0.5em;
    top: 6px;
    left: 8px;
}
/*перейти к предыдущей фотографии*/
/*перейти к следующей фотографии*/
/*перейти на 1-е фото*/
/*перейти на последнее фото*/
/*запустить слайд-шоу*/
.fa-chevron-left:before {content: "\f053";}
.fa-chevron-right:before {content: "\f054";}
.fa-step-backward:before {content: "\f048";}
.fa-step-forward:before {content: "\f051";}
.fa-play:before {content: "\f04b";}
.fa-pause:before {content: "\f04c";}
.fa-window-close-o{
    position: absolute;
    right: -14px;
    top: 0;
    height: 22px;
    width: 22px;
    border-width: 0;
    cursor: pointer;
    font-size: 20px;
    background-color: <?=$button_color?>;
    border-radius: <?=$border_radius?>;
}
.fa-window-close-o:before{
    content: "\f00d";
    top: 2px;
    left: 4px;
}
/*индикатор хода выполнения длительных операций*/
.gv-ind-img {
   background: rgba(0,0,0,0.4) url(<?=GVPB_URL?>ajax-loader.gif) no-repeat scroll center 3px; 
   width: 36px;
   height: 36px;
   border-radius: 4px;
   position: fixed;
   left: 50%;
   top: 50%;
   display: none;
   margin: -18px -18px;
   z-index: 102;
}
