/*
	jQuery gvPhotobox v1.0.1 - 2018-11-12
	(c) 2018 Vladimir Giryavyy - gvsoft.ru/js/gvphotobox
	license: https://www.gnu.org/licenses/gpl-2.0.html
*/

(function($){
// Рамка для просмотра размерных изображений, основной метод плагина
$.fn.gvphotobox = function(o) {
    // значения по умолчанию
    var def = {
        //(число) задержка в миллисекундах перед переходом к следующему изображению при автоматической смене,режим слайдшоу
        delay: 3000,
        indicator: null, //(селектор|элемент) индикатор хода загрузки фото
        animation: false,
        speedOldImgAnim: 'normal', //'normal'|'slow'|'fast'|number(ms)
        speedNewImgAnim: 'normal',
        oldImgAnim: 'hide',//анимационный эффект для старого изображения fadeOut|hide|slideUp
        newImgAnim: 'show',//анимационный эффект для нового изображения fadeIn|show|slideDown
    };
    var current = 0, thumbs$,overlay$,imgBox$;
    var methods = {
    init: function() { //инициализация, настройки, первичные действия плагина
        thumbs$ = $('a',this); // получаем коллекцию из тегов <a> текущей обёртки
        if (! /wp-content\/uploads/i.test( thumbs$[0].href ) ) return;
        o = $.extend({},def,o); // совмещение пользовательских и дефолтовых опций
        if (!o.indicator) o.indicator = $('<div class="gv-ind-img"></div>');
        
        //-----готовим разметку контейнера фотобокса с кнопками управления-----
        imgBox$ = $(
            `<div id="gv-photobox" class="h-centre" style="display: none;">
                <img id="gv-img-display" src="">
                <div class="gv-control-bar">
                    <button id="firstButton" type="button" class="fa fa-step-backward" title="First"></button>
                    <button id="previousButton" type="button" class="fa fa-chevron-left" title="Previous"></button>
                    <button id="playButton" type="button" class="fa fa-play" title="Play (slide-show)"></button>
                    <button id="nextButton" type="button" class="fa fa-chevron-right" title="Next"></button>
                    <button id="lastButton" type="button" class="fa fa-step-forward" title="Last"></button>
                </div>
                <button id="boxClose" type="button" class="fa fa-window-close-o"></button>
            </div>`
        );
        overlay$ = $('<div id="gv-overlay">') //генерим перекрывающую подложку
            .css({position:'absolute',zIndex:100,left:0,top:0,
                background:'#000',opacity:'0.7',width:'100%',height:'100%'});
        //задаем возможности каждой миниатюры обернутого набора:
        thumbs$.each( //присоединяем индекс к каждой миниатюре=порядковый номер
            function(n){ $(this).data('photo-index',n); }
        )
        .click(function(){ // на клик каждого элемента галереи генерация нового окна фотобокса
            imgBox$.appendTo('body');
            o.indicator.appendTo('body');
            overlay$.appendTo('body').css({height:$('body').height()+62});
            showPhoto( $(this).data('photo-index') ); //и фотографию
            return false;
        });
        
        $('body').on('click','#gv-overlay',function(){closeBox();});
        $('body').on('click','#gv-photobox #boxClose',function(){closeBox();});
        $('body').on('click','#gv-photobox #gv-img-display',function(){
            showPhoto( (current+1) % thumbs$.length );
        });
        
        $('body').on('click','#gv-photobox #nextButton',function(){showPhoto((current+1) % thumbs$.length );});
        $('body').on('click','#gv-photobox #previousButton',function(){showPhoto((thumbs$.length+current-1) % thumbs$.length );});
        $('body').on('click','#gv-photobox #firstButton',function(){showPhoto(0);});
        $('body').on('click','#gv-photobox #lastButton',function(){showPhoto(thumbs$.length-1);});
        $('body').on('keydown','#gv-photobox',function(e){
            if (e.keyCode===39) showPhoto((current+1) % thumbs$.length );
            if (e.keyCode===37) showPhoto((thumbs$.length+current-1) % thumbs$.length );
            if (e.keyCode===38) showPhoto(thumbs$.length-1); //up последняя
            if (e.keyCode===40) showPhoto(0);//down первая
            if (e.keyCode===13) playStop(); //Enter слайд-шоу
            if (e.keyCode===27) closeBox(); //Esc закрыть
            return false;
        });

        var notClicked = true;
        // Запуск/останов слайд-шоу
        function playStop() {
            if (notClicked) { //первый клик = запуск воспроизведения (слайд-шоу)
                o.tick = setInterval(function(){$('#nextButton',imgBox$).click();},o.delay);
                //меняем визуально состояние элемента 'воспроизвести' на 'поставить паузу'
                $('#playButton',imgBox$).addClass('fa-pause').attr('title','Stop');
            } else { //второй клик = нажали 'паузу'
                clearInterval(o.tick); //останавливаем таймер,освобождаем ресурс
                $('#gv-img-display',imgBox$).stop(true,true);//останавливаем анимационные эффекты
                //меняем визуально состояние элемента воспроизведения, теперь доступно 'воспроизведение'
                $('#playButton',imgBox$).removeClass('fa-pause').attr('title','Play (slide-show)');
            }
            notClicked = !notClicked;
        };
        //обработка последовательных кликов на элементе "проиграть"
        $('body').on('click','#gv-photobox #playButton',function(){playStop();});
        // Закрыть рамку, убрать из дерева документа
        function closeBox() {
            $('#gv-overlay').remove();$('#gv-photobox').remove();    
        };
        
        return this;
    } //end init          
    }; //end mehods
  
    //по индексу миниатюры, загружает и показывает полноразмерное фото
    var showPhoto = function(index){
        if (o.indicator) o.indicator.show();
        if (!o.animation){
            imgBox$.hide();
            $('#gv-img-display',imgBox$).attr('src', thumbs$[index].href);
        }
        else{
            $('#gv-img-display',imgBox$).css({visibility:'hidden'});
            imgBox$[o.oldImgAnim](o.speedOldImgAnim,function(){
                $('#gv-img-display',imgBox$).attr('src', thumbs$[index].href);
            });
        }
        
        $('#gv-img-display',imgBox$)
            .bind('load', function(){
                if (o.indicator) o.indicator.hide();
                imgBox$.css({marginLeft:-imgBox$.width()/2,marginTop:-imgBox$.height()/2});
                if (!o.animation) imgBox$.show();
                else{
                    imgBox$[o.newImgAnim](o.speedNewImgAnim,function(){
                        $('#gv-img-display',imgBox$).css({visibility:'visible'})
                    });
                }
                $('#nextButton',imgBox$).focus(); //чтобы иметь возможность управлять с клавиатуры
            });
            
        current = index; //запоминаем индекс текущей картинки
    };

    if ( methods[o] ) { // логика вызова метода
        //вызываем метод по запрошенному имени, передаем в качестве контекста обернутый  
        //набор this, и параметры, если таковые имеются(arguments: начиная с 1-го)
        return methods[ o ].apply( this, Array.prototype.slice.call( arguments, 1 ) ); 
    } else if ( typeof o === 'object' || ! o ) { //на входе-объект или вообще ничего: похоже на метод инициализации
        return methods.init.apply( this, arguments );
    } else {
        throw new Error( 'Method ' + o + ' в jQuery.gvphotobox not exist' );
    }
        
  };
    
})(jQuery);

